using System;
using System.Collections.Generic;
using System.Text;
using NationalInstruments.NetworkVariable;

namespace BufferedSubscriber_Bug
{
    class Program
    {
        static void Main(string[] args)
        {
            string variableLocation = "\\\\localhost\\System\\Demo";

            NetworkVariableBufferedSubscriber<double> subscriber = new NetworkVariableBufferedSubscriber<double>(variableLocation);
            subscriber.Connect();
            subscriber.ItemCapacity = 10;

            using (NetworkVariableWriter<double> writer = new NetworkVariableWriter<double>(variableLocation))
            {
                writer.Connect();
                writer.WriteValue(1.0);
                writer.WriteValue(2.0);
            }

            NetworkVariableData<double> readData = subscriber.ReadData();

            // The first read is likely to have a quality of "No Known Value"
            if (readData.HasQuality && readData.Quality ==
                    NetworkVariableDataQualities.NoKnownValue)
            {
                // Pass over the value and accept the next value
                readData = subscriber.ReadData();
            }

            BufferedSubscriberDataStatus status;
            do
            {
                if (readData.HasValue)
                    Console.WriteLine(readData.GetValue().ToString());

                readData = subscriber.ReadData(out status);
            } while (status == BufferedSubscriberDataStatus.New);

            Console.ReadKey();
        }
    }
}
